{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
PROGRAM Rodokmen;
Uses Crt, Graph;

Const MaxObjectOsoba = 500;

Type PohlaviType  = (M,Z);
     IDType       = STRING[10];
     JmenoType    = STRING[32];
     Osoba        = Record
                      ID       : IDType;
                      jmeno    : JmenoType;
                      prijmeni : JmenoType;
                      pohlavi  : PohlaviType;
                      RokNar   : WORD;
                      RokUmr   : WORD;
                      matkaID  : IDType;
                      otecID   : IDType;
                    End;
     OsobaType    = ^Osoba;
     RodokmenType = Object
                      OS       : ARRAY[1..MaxObjectOsoba]OF OsobaType;
                      OSCount  : WORD;

                      DrawBuff : ARRAY[1..10,1..MaxObjectOsoba]OF IDType;

                      constructor Initialize;
                      destructor destroy;
                      function NajdiCislo(_ID : IDType) : WORD;
                      function InDrawBuff(Numb : WORD) : BOOLEAN;

                      procedure AddOsoba(_ID,_matkaID,_otecID : IDType;_Jmeno,_prijmeni : JmenoType;
                                         _Pohlavi : PohlaviType;_RokNar,_RokUmr : WORD);
                      procedure Draw;
                      procedure FinalDraw(_X,_Y : WORD);


                      procedure LoadXML(path : STRING);

                    End;

Var GrDriver, GrMode : INTEGER;

    Rod              : RodokmenType;
    Key              : CHAR;
    Scrool           : Record
                         X,Y : WORD;
                       End;

    FileF            : STRING;




function IntToStr(I : INTEGER) : STRING;{vrati retezec z ciselne hodnoty}
var S : STRING;
begin
  Str(I,S);
  IntToStr := S;
end;



constructor RodokmenType.Initialize;
begin
  OSCount := 0;
end;

destructor RodokmenType.Destroy;
var f1 : INTEGER;
begin
  for f1 := 1 TO OSCount DO
    Dispose(OS[f1]);
end;

function RodokmenType.NajdiCislo(_ID : IDType) : WORD;
var f1 : INTEGER;
begin
  if OSCount<>0 then
    for f1 := 1 TO OSCount DO
      if OS[f1]^.ID=_ID then NajdiCislo := f1;
end;

function RodokmenType.InDrawBuff(Numb : WORD) : BOOLEAN;
var ffx, ffy : INTEGER;
begin
  InDrawBuff := false;
  for ffx := 1 TO 10 DO
    for ffy := 1 TO MaxObjectOsoba DO
      if NajdiCislo(DrawBuff[ffx,ffy])=Numb then InDrawBuff := true;
end;


procedure RodokmenType.AddOsoba(_ID,_matkaID,_otecID : IDType;_Jmeno,_prijmeni : JmenoType;
                                _Pohlavi : PohlaviType;_RokNar,_RokUmr : WORD);
begin
  Inc(OSCount);
  New(OS[OSCount]);

  with OS[OSCount]^ DO
  begin
    ID       := _ID;
    matkaID  := _matkaID;
    otecID   := _otecID;
    Jmeno    := _Jmeno;
    prijmeni := _prijmeni;
    pohlavi  := _pohlavi;
    RokNar   := _RokNar;
    RokUmr   := _RokUmr;
  end;
end;

procedure RodokmenType.LoadXML(path : STRING);
var T        : TEXT;

    ReadLine : STRING;
    W,W2     : STRING;
    StrN     : WORD;
    Osob     : Osoba;
    Code     : WORD;

    NewOsoba : BOOLEAN;

    f1,f2    : INTEGER;

    proces   : WORD;
    lines    : WORD;
    aktLine  : WORD;
    S        : STRING;

begin
  assign(T,path);
  reset(T);

  lines := 0;

  repeat
     ReadLn(T,ReadLine);
     lines := lines+1;
  Until ReadLine='';

  Close(T);


  assign(T,path);
  reset(T);

  AktLine := 0;
  repeat
    ReadLn(T,ReadLine);
    AktLine := AktLine+1;



    W    := '';
    StrN := 0;
    f1   := 0;
    repeat
      f1 := f1+1;

      if ReadLine[f1]<>' ' then W := W+UpCase(ReadLine[f1]);

      StrN := f1;

    Until ReadLine[f1]='>';


    if W='<OSOBA>' then
    begin
      NewOsoba      := true;
      osob.ID       := '';
      osob.matkaID  := '';
      osob.otecID   := '';
      osob.pohlavi  := M;
      osob.jmeno    := '';
      osob.prijmeni := '';
      osob.RokNar   := 0;
      osob.RokUmr   := 0;
    end;

    if W='<ID>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Osob.id := W2;
    end;
    if W='<JMENO>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Osob.jmeno := W2;
    end;
    if W='<PRIJMENI>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Osob.prijmeni := W2;
    end;
    if W='<MATKA>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Osob.matkaID := W2;
    end;
    if W='<OTEC>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Osob.otecID := W2;
    end;
    if W='<POHLAVI>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      if W2='M' then Osob.pohlavi := M
                else Osob.pohlavi := Z;
    end;
    if W='<NAROZENI>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Val(W2,Osob.RokNar,Code);
    end;
    if W='<UMRTI>' then
    begin
      for f1 := 1 TO Length(ReadLine) DO
        if ReadLine[f1]='>' then
        begin
          f2 := StrN;
          W2 := '';
          Repeat
            f2 := f2+1;
            if ReadLine[f2]<>'<' then W2 := W2+ReadLine[f2];

          Until ReadLine[f2]='<'
        end;

      Val(W2,Osob.RokUmr,Code);
    end;

    if W='<JMENO/>' then
      Osob.jmeno := '';
    if W='<PRIJMENI/>' then
      Osob.prijmeni := '';
    if W='<MATKA/>' then
      Osob.matkaID := '';
    if W='<OTEC/>' then
      Osob.otecID := '';
    if W='<POHLAVI/>' then
      osob.pohlavi := M;
    if W='<NAROZENI/>' then
      Osob.RokNar := 0;
    if W='<UMRTI/>' then
      Osob.RokUmr := 0;





    if W='</OSOBA>' then
    begin
      NewOsoba := false;
      AddOsoba(Osob.ID,Osob.matkaID,Osob.otecID,Osob.Jmeno,Osob.Prijmeni,
               Osob.pohlavi,Osob.RokNar,Osob.RokUmr);

    end;



    SetColor(0);
    OutTextXY(20,20,'Complete : '+S+' lines');
    Str(AktLine,S);
    SetColor(Random(15)+1);
    OutTextXY(20,20,'Complete : '+S+' lines');



  Until (W='</RODOKMEN>')OR(AktLine=Lines);

  close(T);
end;

procedure RodokmenType.Draw;
var   f1,f2       : INTEGER;
      fx,fy       : INTEGER;
      fx2,fy2     : INTEGER;

      Osob1,Osob2 : Osoba;

      S,S2        : STRING;
label NoOsoba;


begin
  if OSCount = 0 then goto NoOsoba;

  {serazeni podle roku narozeni}
  for f2 := 1 TO OSCount DO
    for f1 := 1 TO OSCount-1 DO
    begin
      Osob1 := OS[f1]^;
      Osob2 := OS[f1+1]^;

      if OS[f1+1]^.RokNar>OS[f1]^.RokNar then
      begin
        OS[f1+1]^ := Osob1;
        OS[f1]^   := Osob2;
      end;

      OutTextXY(10,1,'Serazuji');
    end;

  {usporadani stromu}
  for fx := 1 TO 10 DO
    for fy := 1 TO MaxObjectOsoba DO
      DrawBuff[fx,fy] := '';

  fx := 1;
  fy := 1;
  for f1 := 1 TO OSCount DO
  begin
      if InDrawBuff(f1)=false then
      begin
        DrawBuff[fx,f1+fy] := OS[f1]^.ID;
      end
                              else fy := fy-1;

      if OS[f1]^.otecID<>'' then
        if InDrawBuff(NajdiCislo(OS[f1]^.matkaID))=false then
        begin
          fy := fy+1;
          DrawBuff[fx,f1+fy] := OS[f1]^.matkaID;
        end;

      if OS[f1]^.matkaID<>'' then
        if InDrawBuff(NajdiCislo(OS[f1]^.otecID))=false then
        begin
          fx := fx+1;
          DrawBuff[fx,f1+fy] := OS[f1]^.otecID;
        end;
      SetColor(0);
      OutTextXY(10,10,'Usporadani '+S+' lines');
      Str(f1,S);
      SetColor(Random(15)+1);
      OutTextXY(10,10,'Usporadani '+S+' lines');
  end;



  NoOsoba :
end;

procedure RodokmenType.FinalDraw(_X,_Y : WORD);
var fx,fy : INTEGER;

  procedure DrawOsoba(OsNumber : WORD;X,Y : INTEGER);
  begin
    with OS[OsNumber]^ DO
    begin
      SetFillStyle(1,LightBlue);
      Bar(X,Y,X+240,Y+70);
      SetColor(white);
      Rectangle(X,Y,X+240,Y+70);


      OutTextXY(X,Y,'ID : '+ID);
      OutTextXY(X,Y+10,'Jmeno : '+jmeno+' '+prijmeni);
      if otecID<>''  then OutTextXY(X,Y+20,'Matka : '+OS[NajdiCislo(matkaID)]^.jmeno+' '+OS[NajdiCislo(matkaID)]^.prijmeni);
      if matkaID<>'' then OutTextXY(X,Y+30,'Otec  : '+OS[NajdiCislo(otecID)]^.jmeno+' '+OS[NajdiCislo(otecID)]^.prijmeni);
      if pohlavi = Z then OutTextXY(X,Y+40,'Pohlavi : ZENA')
                     else OutTextXY(X,Y+40,'Pohlavi : MUZ');
      OutTextXY(X,Y+50,'RokNarozeni : '+IntToStr(RokNar));
      if RokUmr <> 0 then OutTextXY(X,Y+60,'RokUmrti : '+IntToStr(RokUmr));

    end;
  end;


begin
  {vykresleni stromu}
  for fx := _X TO _Y+4 DO
    for fy := _X TO _Y+6 DO
      if (DrawBuff[fx,fy]<>'') then
      begin
        DrawOsoba(NajdiCislo(DrawBuff[fx,fy]),(fx-1)*250+_X*250,(fy-2)*80+_Y*80);
      end;
end;





BEGIN
  Write('Jmeno Souboru : ');
  ReadLn(FileF);

  Randomize;

  GrDriver := 9;
  GrMode   := 1;

  InitGraph(GrDriver,GrMode,'');
  Rod.Initialize;

  Rod.LoadXML(FileF);

  Scrool.X := 0;
  Scrool.Y := 0;

  Rod.Draw;

  repeat
    SetFillStyle(1,0);
    Bar(0,0,GetMaxX,GetMaxY);

    Rod.FinalDraw(Scrool.X,Scrool.Y);

    Key := ReadKey;

    Case Key OF
      '4' : Scrool.X := Scrool.X+1;
      '6' : Scrool.X := Scrool.X-1;
      '5' : Scrool.Y := Scrool.Y-1;
      '8' : Scrool.Y := Scrool.Y+1;
    End;

  until Key=#27;

  Rod.Destroy;
  CloseGraph;

END.